
@read_KADEX.pro


PRO VMipas_Quit, event

  Widget_Control, event.top, /Destroy
END ;---------------------------------------------------------------------------

PRO Vmipas_ZvsVmr, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

  ; Get file data
    filesav = Filepath(Root_Dir=ProgramRootDir(), SUBDIR=['savfiles'], 'vmipas_' $
           +info.file_name+'.sav')
    RESTORE, FILENAME = filesav

    Index = Widget_Info(info.tableID, /Table_Select)
    currentIndex = Index[1]

    IF d.header.n_geo GT currentIndex THEN BEGIN

    valid = where(*d.result[currentIndex].visibility gt 0, count)

    IAA_Plot, (*d.result[currentIndex].target)[valid], (*d.result[currentIndex].altitude)[valid], Group_leader=event.top, $
        YTitle='Z', XTitle='vmr', Title=d.header.target_name+'!C'+d.result[currentIndex].geo_id

    ENDIF ELSE BEGIN

    ok = DIALOG_MESSAGE('Please, select profile in table', /information)

    ENDELSE

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------


PRO VMipas_PvsVmr, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

  ; Get file data
    filesav = Filepath(Root_Dir=ProgramRootDir(), SUBDIR=['savfiles'], 'vmipas_' $
           +info.file_name+'.sav')
    RESTORE, FILENAME = filesav

    Index = Widget_Info(info.tableID, /Table_Select)
    currentIndex = Index[1]

    IF d.header.n_geo GT currentIndex THEN BEGIN

    valid = where(*d.result[currentIndex].visibility gt 0, count)

    IAA_Plot, (*d.result[currentIndex].target)[valid], (*d.result[currentIndex].pressure)[valid], Group_leader=event.top, $
        YTitle='Pressure', XTitle='vmr', Title=d.header.target_name+'!C'+d.result[currentIndex].geo_id

    ENDIF ELSE BEGIN

    ok = DIALOG_MESSAGE('Please, select profile in table', /information)

    ENDELSE

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------


PRO VMipas_TvsZ, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

  ; Get file data
    filesav = Filepath(Root_Dir=ProgramRootDir(), SUBDIR=['savfiles'], 'vmipas_' $
           +info.file_name+'.sav')
    RESTORE, FILENAME = filesav

    Index = Widget_Info(info.tableID, /Table_Select)
    currentIndex = Index[1]

    IF d.header.n_geo GT currentIndex THEN BEGIN

    valid = where(*d.result[currentIndex].visibility gt 0, count)

    IAA_Plot, (*d.result[currentIndex].altitude)[valid], (*d.result[currentIndex].temperature)[valid], Group_leader=event.top, $
        YTitle='Temperature', XTitle='Z', Title=d.header.target_name+'!C'+d.result[currentIndex].geo_id

    ENDIF ELSE BEGIN

    ok = DIALOG_MESSAGE('Please, select profile in table', /information)

    ENDELSE




   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------


PRO VMipas_Contour, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

IAA_Contour, Group_leader=event.top

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------


PRO VMipas_about, event

value = [$
'', $
'VMipas Version 1.0', $
'', $
'Jos Enrique Ruiz', $
'Dept. del Sistema Solar', $
'Instituto Astrofsica de Andaluca', $
'CSIC', $
'' $
]

about = DIALOG_MESSAGE(value, /information)

END ;---------------------------------------------------------------------------

PRO VMipas_SelectFile, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

    currentIndex = Widget_Info(info.dropID, /DropList_Select)
    Widget_Control, info.dropID, Get_UValue=droplistValues

   ; Get file data
    filesav = Filepath(Root_Dir=ProgramRootDir(), SUBDIR=['savfiles'], 'vmipas_' $
           +droplistValues[currentIndex]+'.sav')
    RESTORE, FILENAME = filesav

   ; Read files headers
    record = {date:'', lat:0., lon:0., sza:0.}

    target = d.header.target_name
    altitude = d.header.altitude_range
    profiles = d.header.n_geo

    dataheader = replicate(record, d.header.n_geo)
    dataheader.date = d.header.date
    dataheader.lat = d.header.latitude
    dataheader.lon = d.header.longitude
    dataheader.sza = d.header.sza

    ; Modify target label
    WIDGET_CONTROL, info.targetID, SET_VALUE='Target Name : '+String(target)

    ; Modify altitude range label
    WIDGET_CONTROL, info.altitudeID, SET_VALUE='Altitude range [ km ] : '+String(altitude[0])+', '$
           +String(altitude[1])

    ; Modify profiles label
    WIDGET_CONTROL, info.profilesID, SET_VALUE='Profiles : '+String(profiles)

    ; Modify table
    WIDGET_CONTROL, info.tableID, SET_VALUE=dataheader

    ; Put file_name into info structure
    info.file_name=d.header.file_name


  ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------


PRO VMipas_OpenFile, event

   ; Get the info structure and copy it here.

Widget_Control, event.top, Get_UValue=info, /No_Copy

Catch, theError
IF theError NE 0 THEN BEGIN
   Catch, /Cancel
   ok = Error_Message(Traceback=1)
   RETURN
ENDIF

files = DIALOG_PICKFILE(/READ, /MULTIPLE_FILES)

IF FILES[0] NE '' THEN BEGIN

    IF Ptr_Valid(info.savfiles) THEN $
    file_delete, *info.savfiles, /allow_nonexistent, /quiet

    file_list = strArr(N_Elements(files))
    savfiles = strArr(N_Elements(files))

   ; Read files
    record = {date:'', lat:0., lon:0., sza:0.}

    FOR i=0, N_Elements(files)-1 DO BEGIN

       w = read_kadex(d, files[i])
       file_list[i] = d.header.file_name

       ; Get file data
       IF i EQ 0 THEN BEGIN
         target = d.header.target_name
         altitude = d.header.altitude_range
         profiles = d.header.n_geo

         dataheader = replicate(record, d.header.n_geo)
         dataheader.date = d.header.date
         dataheader.lat = d.header.latitude
         dataheader.lon = d.header.longitude
         dataheader.sza = d.header.sza

         ; Put file_name into info structure
         info.file_name=d.header.file_name
       ENDIF

       filesav = Filepath(Root_Dir=ProgramRootDir(), SUBDIR=['savfiles'], 'vmipas_'+d.header.file_name+'.sav')
       SAVE, d, FILENAME = filesav

       savfiles[i] = filesav

   ENDFOR


   ; Put savfiles into info structure
   savptr = Ptr_New(savfiles)
   info.savfiles=savptr

   ; Sensitizing menus
   WIDGET_CONTROL, info.closeID, SENSITIVE=1
   WIDGET_CONTROL, info.plotsID, SENSITIVE=1
   ;WIDGET_CONTROL, info.contoursID, SENSITIVE=1
   WIDGET_CONTROL, info.targetID, SENSITIVE=1
   WIDGET_CONTROL, info.altitudeID, SENSITIVE=1
   WIDGET_CONTROL, info.profilesID, SENSITIVE=1

   ; Modify drop
   WIDGET_CONTROL, info.dropID, SENSITIVE=1
   WIDGET_CONTROL, info.dropID, SET_VALUE=file_list
   WIDGET_CONTROL, info.dropID, SET_UVALUE=file_list

   ; Modify target label
   WIDGET_CONTROL, info.targetID, SET_VALUE='Target Name : '+String(target)

   ; Modify altitude range label
   WIDGET_CONTROL, info.altitudeID, SET_VALUE='Altitude range [ km ] : '+String(altitude[0])+', '$
           +String(altitude[1])

   ; Modify profiles label
   WIDGET_CONTROL, info.profilesID, SET_VALUE='Profiles : '+String(profiles)

   ; Modify table
   WIDGET_CONTROL, info.tableID, SET_VALUE=dataheader


ENDIF

   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------



PRO VMipas_CloseFile, event

   ; Get the info structure and copy it here.
Widget_Control, event.top, Get_UValue=info, /No_Copy


   ; Sensitizing menus
   WIDGET_CONTROL, info.plotsID, SENSITIVE=0
   WIDGET_CONTROL, info.contoursID, SENSITIVE=0
   WIDGET_CONTROL, info.closeID, SENSITIVE=0

  ; Modify drop
   WIDGET_CONTROL, info.dropID, SET_VALUE=''
   WIDGET_CONTROL, info.dropID, SENSITIVE=0

   ; Modify table
   WIDGET_CONTROL, info.tableID, SET_VALUE=strArr(6)

   ; Reset files in info structure
   file_delete, *info.savfiles, /allow_nonexistent

   info.file_name=''
   info.savfiles=Ptr_New()



   ; Put the info structure back in its storage location.

Widget_Control, event.top, Set_UValue=info, /No_Copy
END ;---------------------------------------------------------------------------

PRO VMipas_Cleanup, tlb

Widget_Control, tlb, Get_UValue=info, /No_Copy

IF N_Elements(info) EQ 0 THEN RETURN

IF Ptr_Valid(info.savfiles) THEN $
    file_delete, *info.savfiles, /allow_nonexistent, /quiet

; Clean pointers
Ptr_Free, info.savfiles
heap_gc


END ;---------------------------------------------------------------------------

PRO VMipas

   ; Catch any error in the VMipas program.

Catch, theError
IF theError NE 0 THEN BEGIN
   Catch, /Cancel
   ok = Error_Message(Traceback=1)
   RETURN
ENDIF


IF XRegistered('vmipas') GT 0 THEN BEGIN
  ok = Dialog_Message('Only one VMIPAS can be used at once.')
  RETURN
ENDIF

   ; Define the TLB.

tlb = Widget_Base(Column=1, /tlb_frame_attr, Title='VMipas 1.0', MBar=menubarID)

   ; Define the File pull-down menu.

fileID = Widget_Button(menubarID, Value='File')
openID = Widget_Button(fileID, Value='Open...', Event_Pro='VMipas_OpenFile')
closeID = Widget_Button(fileID, Value='Close file(s)', Event_Pro='VMipas_CloseFile', SENSITIVE=0)
quitID = Widget_Button(fileID, Value='Quit', Event_Pro='VMipas_Quit')

   ; Define the 1D pull-down menu.

plotsID = Widget_Button(menubarID, Value='1D Plots', SENSITIVE=0)
button = Widget_Button(plotsID, Value='Z vs [vmr]', Event_Pro='VMipas_ZvsVmr')
button = Widget_Button(plotsID, Value='P vs [vmr]', Event_Pro='VMipas_PvsVmr')
button = Widget_Button(plotsID, Value='T vs Z', Event_Pro='VMipas_TvsZ')


   ; Define the 2D pull-down menu.

contoursID = Widget_Button(menubarID, Value='2D Contour', SENSITIVE=0)
button = Widget_Button(contoursID, Value='Example 1', Event_Pro='VMipas_Contour')
button = Widget_Button(contoursID, Value='Example 2', Event_Pro='VMipas_Contour')
button = Widget_Button(contoursID, Value='Example 3', Event_Pro='VMipas_Contour')

   ; Define the Help pull-down menu.

HelpID = Widget_Button(menubarID, Value='Help')
button = Widget_Button(HelpID, Value='About...', Event_Pro='VMipas_About')


   ; Define droplist files widget.

space = CW_Spacer(tlb)
droptlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(droptlb)
dropID = Widget_DropList(droptlb, value='', title='File :', SENSITIVE=0, /DYNAMIC_RESIZE, $
       Event_Pro='VMipas_SelectFile', uvalue='')

   ; Define label widgets.

targetlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(targetlb)
targetID = Widget_label(targetlb, value='Target name :', SENSITIVE=0, /DYNAMIC_RESIZE)

altitudetlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(altitudetlb)
altitudeID = Widget_label(altitudetlb, value='Altitude range  [ km ] :', SENSITIVE=0, /DYNAMIC_RESIZE)

profilestlb = Widget_Base(tlb, Row=1)
space = CW_Spacer(profilestlb)
profilesID = Widget_label(profilestlb, value='Profiles :', SENSITIVE=0, /DYNAMIC_RESIZE)

   ; Define table widget.

names=['DATE', 'LAT', 'LON', 'SZA']

tabletlb = Widget_Base(tlb, Row=1, /align_center)
space = CW_Spacer(tabletlb)

c_widths = [110, 70, 70, 70]
tableID = Widget_Table(tabletlb, value=strArr(4), YSIZE=100, Y_SCROLL_SIZE=15,$
       COLUMN_LABELS=names, /NO_ROW_HEADERS, /RESIZEABLE_COLUMNS, COLUMN_WIDTHS=c_widths, UNITS=0)
space = CW_Spacer(tabletlb)

   ; Realize the widget hierarchy.

Widget_Control, tlb, /Realize

   ; Create the info structure with the information
   ; required to run the program.

info = {tableID:tableID, $
        plotsID:plotsID, $
        closeID:closeID, $
        contoursID:contoursID, $
        dropID:dropID, $
        targetID:targetID, $
        profilesID:profilesID, $
        altitudeID:altitudeID, $
        file_name:'', $
        savfiles: ptr_new() $
        }

   ; Store the info structure in the user value of the TLB.

Widget_Control, tlb, Set_UValue=info, /No_Copy

   ; Set up the event loop. Register the program with the window manager.

XManager, 'vmipas', tlb, /No_Block, Cleanup='VMipas_Cleanup'
END ;---------------------------------------------------------------------------